import React, { Component } from 'react';

export class TodoApp extends Component {

  constructor(props) {
    super(props);
    this.state = {items: [], newItem: ""};
  }

  render = () => {
    return (
      <div>
        <h1>To-Do List</h1>
        {this.renderItems()}
        <div>
          <label htmlFor='item-input'>New item:</label>
          <input type="text" value={this.state.newItem}
              onChange={this.doNewItemChange} id='item-input'/>
          <button type="button"
              onClick={this.doAddClick}>Add Item</button>
        </div>
      </div>
    );
  }

  renderItems = () => {
    const items = [];
    for (let i = 0; i < this.state.items.length; i++) {
      items.push(
        <li key={i}>{this.state.items[i].name}</li>);
    }
    return <ul>{items}</ul>;
  };

  doNewItemChange = (evt) => {
    this.setState({newItem: evt.target.value});
  }

  doAddClick = (evt) => {
    // Ignore the request if the user hasn't entered a name.
    // (Would be better to disable the button in this case.)
    const name = this.state.newItem.trim();
    if (name.length == 0)
      return;

    const items = this.state.items.concat([{name: name, completed: false}]);
    this.setState({items: items, newItem: ""});
  }
}
